// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::GraphView;
use glib::{prelude::*, translate::*};
use std::fmt;

glib::wrapper! {
    #[doc(alias = "DzlCpuGraph")]
    pub struct CpuGraph(Object<ffi::DzlCpuGraph, ffi::DzlCpuGraphClass>) @extends GraphView, gtk::DrawingArea, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_cpu_graph_get_type(),
    }
}

impl CpuGraph {
    #[doc(alias = "dzl_cpu_graph_new_full")]
    pub fn new_full(timespan: i64, max_samples: u32) -> CpuGraph {
        assert_initialized_main_thread!();
        unsafe {
            gtk::Widget::from_glib_none(ffi::dzl_cpu_graph_new_full(timespan, max_samples))
                .unsafe_cast()
        }
    }

    #[doc(alias = "max-samples")]
    pub fn max_samples(&self) -> u32 {
        ObjectExt::property(self, "max-samples")
    }

    pub fn timespan(&self) -> i64 {
        ObjectExt::property(self, "timespan")
    }
}

impl fmt::Display for CpuGraph {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("CpuGraph")
    }
}
